# coding: utf-8

# Code generated by Kucoin Universal SDK Generator; DO NOT EDIT.

from __future__ import annotations
import pprint
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional


class DeleteSubAccountApiReq(BaseModel):
    """
    DeleteSubAccountApiReq

    Attributes:
        api_key (str): API-Key
        sub_name (str): Sub-account name.
        passphrase (str): Password(Password of the API key)
    """

    api_key: Optional[str] = Field(default=None,
                                   description="API-Key",
                                   alias="apiKey")
    sub_name: Optional[str] = Field(default=None,
                                    description="Sub-account name.",
                                    alias="subName")
    passphrase: Optional[str] = Field(
        default=None, description="Password(Password of the API key)")

    __properties: ClassVar[List[str]] = ["apiKey", "subName", "passphrase"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=False,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        return self.model_dump_json(by_alias=True, exclude_none=True)

    @classmethod
    def from_json(cls, json_str: str) -> Optional[DeleteSubAccountApiReq]:
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        _dict = self.model_dump(
            by_alias=True,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(
            cls, obj: Optional[Dict[str,
                                    Any]]) -> Optional[DeleteSubAccountApiReq]:
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "apiKey": obj.get("apiKey"),
            "subName": obj.get("subName"),
            "passphrase": obj.get("passphrase")
        })
        return _obj


class DeleteSubAccountApiReqBuilder:

    def __init__(self):
        self.obj = {}

    def set_api_key(self, value: str) -> DeleteSubAccountApiReqBuilder:
        """
        API-Key
        """
        self.obj['apiKey'] = value
        return self

    def set_sub_name(self, value: str) -> DeleteSubAccountApiReqBuilder:
        """
        Sub-account name.
        """
        self.obj['subName'] = value
        return self

    def set_passphrase(self, value: str) -> DeleteSubAccountApiReqBuilder:
        """
        Password(Password of the API key)
        """
        self.obj['passphrase'] = value
        return self

    def build(self) -> DeleteSubAccountApiReq:
        return DeleteSubAccountApiReq(**self.obj)
