# Code generated by Kucoin Universal SDK Generator; DO NOT EDIT.

from abc import ABC, abstractmethod
from typing import Any
from kucoin_universal_sdk.internal.interfaces.transport import Transport
from .model_get_rebase_req import GetRebaseReq
from .model_get_rebase_resp import GetRebaseResp


class APIBrokerAPI(ABC):

    @abstractmethod
    def get_rebase(self, req: GetRebaseReq, **kwargs: Any) -> GetRebaseResp:
        """
        summary: Get Broker Rebate
        description: This interface supports downloading Broker rebate orders
        documentation: https://www.kucoin.com/docs-new/api-3470280
        +---------------------+------------+
        | Extra API Info      | Value      |
        +---------------------+------------+
        | API-DOMAIN          | SPOT       |
        | API-CHANNEL         | PRIVATE    |
        | API-PERMISSION      | GENERAL    |
        | API-RATE-LIMIT-POOL | MANAGEMENT |
        | API-RATE-LIMIT      | 3          |
        +---------------------+------------+
        """
        pass


class APIBrokerAPIImpl(APIBrokerAPI):

    def __init__(self, transport: Transport):
        self.transport = transport

    def get_rebase(self, req: GetRebaseReq, **kwargs: Any) -> GetRebaseResp:
        return self.transport.call("spot", True, "GET",
                                   "/api/v1/broker/api/rebase/download", req,
                                   GetRebaseResp(), False, **kwargs)
