# coding: utf-8

# Code generated by Kucoin Universal SDK Generator; DO NOT EDIT.

from __future__ import annotations
import pprint
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from kucoin_universal_sdk.internal.interfaces.response import Response
from kucoin_universal_sdk.model.common import RestResponse


class AddSubAccountResp(BaseModel, Response):
    """
    AddSubAccountResp

    Attributes:
        account_name (str): Sub-Account name 
        uid (str): Sub-Account UID
        created_at (int): Creation time, unix timestamp (milliseconds)
        level (int): Subaccount VIP level
    """

    common_response: Optional[RestResponse] = Field(
        default=None, description="Common response")
    account_name: Optional[str] = Field(default=None,
                                        description="Sub-Account name ",
                                        alias="accountName")
    uid: Optional[str] = Field(default=None, description="Sub-Account UID")
    created_at: Optional[int] = Field(
        default=None,
        description="Creation time, unix timestamp (milliseconds)",
        alias="createdAt")
    level: Optional[int] = Field(default=None,
                                 description="Subaccount VIP level")

    __properties: ClassVar[List[str]] = [
        "accountName", "uid", "createdAt", "level"
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=False,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        return self.model_dump_json(by_alias=True, exclude_none=True)

    @classmethod
    def from_json(cls, json_str: str) -> Optional[AddSubAccountResp]:
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        _dict = self.model_dump(
            by_alias=True,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(
            cls, obj: Optional[Dict[str, Any]]) -> Optional[AddSubAccountResp]:
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "accountName": obj.get("accountName"),
            "uid": obj.get("uid"),
            "createdAt": obj.get("createdAt"),
            "level": obj.get("level")
        })
        return _obj

    def set_common_response(self, response: RestResponse):
        self.common_response = response
