# coding: utf-8

# Code generated by Kucoin Universal SDK Generator; DO NOT EDIT.

from __future__ import annotations
import pprint
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional


class GetPrivateFundingHistoryReq(BaseModel):
    """
    GetPrivateFundingHistoryReq

    Attributes:
        symbol (str): Symbol of the contract, Please refer to [Get Symbol endpoint: symbol](https://www.kucoin.com/docs-new/api-3470220) 
        from_ (int): Begin time (milisecond) 
        to (int): End time (milisecond) 
        reverse (bool): This parameter functions to judge whether the lookup is forward or not. True means “yes” and False means “no”. This parameter is set as true by default 
        offset (int): Start offset. The unique attribute of the last returned result of the last request. The data of the first page will be returned by default. 
        forward (bool): This parameter functions to judge whether the lookup is forward or not. True means “yes” and False means “no”. This parameter is set as true by default 
        max_count (int): Max record count. The default record count is 10
    """

    symbol: Optional[str] = Field(
        default=None,
        description=
        "Symbol of the contract, Please refer to [Get Symbol endpoint: symbol](https://www.kucoin.com/docs-new/api-3470220) "
    )
    from_: Optional[int] = Field(default=None,
                                 description="Begin time (milisecond) ",
                                 alias="from")
    to: Optional[int] = Field(default=None,
                              description="End time (milisecond) ")
    reverse: Optional[bool] = Field(
        default=None,
        description=
        "This parameter functions to judge whether the lookup is forward or not. True means “yes” and False means “no”. This parameter is set as true by default "
    )
    offset: Optional[int] = Field(
        default=None,
        description=
        "Start offset. The unique attribute of the last returned result of the last request. The data of the first page will be returned by default. "
    )
    forward: Optional[bool] = Field(
        default=None,
        description=
        "This parameter functions to judge whether the lookup is forward or not. True means “yes” and False means “no”. This parameter is set as true by default "
    )
    max_count: Optional[int] = Field(
        default=None,
        description="Max record count. The default record count is 10",
        alias="maxCount")

    __properties: ClassVar[List[str]] = [
        "symbol", "from", "to", "reverse", "offset", "forward", "maxCount"
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=False,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        return self.model_dump_json(by_alias=True, exclude_none=True)

    @classmethod
    def from_json(cls, json_str: str) -> Optional[GetPrivateFundingHistoryReq]:
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        _dict = self.model_dump(
            by_alias=True,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(
        cls,
        obj: Optional[Dict[str,
                           Any]]) -> Optional[GetPrivateFundingHistoryReq]:
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "symbol": obj.get("symbol"),
            "from": obj.get("from"),
            "to": obj.get("to"),
            "reverse": obj.get("reverse"),
            "offset": obj.get("offset"),
            "forward": obj.get("forward"),
            "maxCount": obj.get("maxCount")
        })
        return _obj


class GetPrivateFundingHistoryReqBuilder:

    def __init__(self):
        self.obj = {}

    def set_symbol(self, value: str) -> GetPrivateFundingHistoryReqBuilder:
        """
        Symbol of the contract, Please refer to [Get Symbol endpoint: symbol](https://www.kucoin.com/docs-new/api-3470220) 
        """
        self.obj['symbol'] = value
        return self

    def set_from_(self, value: int) -> GetPrivateFundingHistoryReqBuilder:
        """
        Begin time (milisecond) 
        """
        self.obj['from'] = value
        return self

    def set_to(self, value: int) -> GetPrivateFundingHistoryReqBuilder:
        """
        End time (milisecond) 
        """
        self.obj['to'] = value
        return self

    def set_reverse(self, value: bool) -> GetPrivateFundingHistoryReqBuilder:
        """
        This parameter functions to judge whether the lookup is forward or not. True means “yes” and False means “no”. This parameter is set as true by default 
        """
        self.obj['reverse'] = value
        return self

    def set_offset(self, value: int) -> GetPrivateFundingHistoryReqBuilder:
        """
        Start offset. The unique attribute of the last returned result of the last request. The data of the first page will be returned by default. 
        """
        self.obj['offset'] = value
        return self

    def set_forward(self, value: bool) -> GetPrivateFundingHistoryReqBuilder:
        """
        This parameter functions to judge whether the lookup is forward or not. True means “yes” and False means “no”. This parameter is set as true by default 
        """
        self.obj['forward'] = value
        return self

    def set_max_count(self, value: int) -> GetPrivateFundingHistoryReqBuilder:
        """
        Max record count. The default record count is 10
        """
        self.obj['maxCount'] = value
        return self

    def build(self) -> GetPrivateFundingHistoryReq:
        return GetPrivateFundingHistoryReq(**self.obj)
