# coding: utf-8

# Code generated by Kucoin Universal SDK Generator; DO NOT EDIT.

from __future__ import annotations
import pprint
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional


class GetPartOrderBookReq(BaseModel):
    """
    GetPartOrderBookReq

    Attributes:
        symbol (str): Symbol of the contract, Please refer to [Get Symbol endpoint: symbol](https://www.kucoin.com/docs-new/api-3470220) 
        size (str): Get the depth layer, optional value: 20, 100
    """

    symbol: Optional[str] = Field(
        default=None,
        description=
        "Symbol of the contract, Please refer to [Get Symbol endpoint: symbol](https://www.kucoin.com/docs-new/api-3470220) "
    )
    size: Optional[str] = Field(
        default=None,
        path_variable="True",
        description="Get the depth layer, optional value: 20, 100")

    __properties: ClassVar[List[str]] = ["symbol", "size"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=False,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        return self.model_dump_json(by_alias=True, exclude_none=True)

    @classmethod
    def from_json(cls, json_str: str) -> Optional[GetPartOrderBookReq]:
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        _dict = self.model_dump(
            by_alias=True,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(
            cls, obj: Optional[Dict[str,
                                    Any]]) -> Optional[GetPartOrderBookReq]:
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "symbol": obj.get("symbol"),
            "size": obj.get("size")
        })
        return _obj


class GetPartOrderBookReqBuilder:

    def __init__(self):
        self.obj = {}

    def set_symbol(self, value: str) -> GetPartOrderBookReqBuilder:
        """
        Symbol of the contract, Please refer to [Get Symbol endpoint: symbol](https://www.kucoin.com/docs-new/api-3470220) 
        """
        self.obj['symbol'] = value
        return self

    def set_size(self, value: str) -> GetPartOrderBookReqBuilder:
        """
        Get the depth layer, optional value: 20, 100
        """
        self.obj['size'] = value
        return self

    def build(self) -> GetPartOrderBookReq:
        return GetPartOrderBookReq(**self.obj)
