# coding: utf-8

# Code generated by Kucoin Universal SDK Generator; DO NOT EDIT.

from __future__ import annotations
import pprint
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional


class GetMaxOpenSizeReq(BaseModel):
    """
    GetMaxOpenSizeReq

    Attributes:
        symbol (str): Symbol of the contract, Please refer to [Get Symbol endpoint: symbol](https://www.kucoin.com/docs-new/api-3470220) 
        price (str): Order price 
        leverage (int): Leverage 
    """

    symbol: Optional[str] = Field(
        default=None,
        description=
        "Symbol of the contract, Please refer to [Get Symbol endpoint: symbol](https://www.kucoin.com/docs-new/api-3470220) "
    )
    price: Optional[str] = Field(default=None, description="Order price ")
    leverage: Optional[int] = Field(default=None, description="Leverage ")

    __properties: ClassVar[List[str]] = ["symbol", "price", "leverage"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=False,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        return self.model_dump_json(by_alias=True, exclude_none=True)

    @classmethod
    def from_json(cls, json_str: str) -> Optional[GetMaxOpenSizeReq]:
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        _dict = self.model_dump(
            by_alias=True,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(
            cls, obj: Optional[Dict[str, Any]]) -> Optional[GetMaxOpenSizeReq]:
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "symbol": obj.get("symbol"),
            "price": obj.get("price"),
            "leverage": obj.get("leverage")
        })
        return _obj


class GetMaxOpenSizeReqBuilder:

    def __init__(self):
        self.obj = {}

    def set_symbol(self, value: str) -> GetMaxOpenSizeReqBuilder:
        """
        Symbol of the contract, Please refer to [Get Symbol endpoint: symbol](https://www.kucoin.com/docs-new/api-3470220) 
        """
        self.obj['symbol'] = value
        return self

    def set_price(self, value: str) -> GetMaxOpenSizeReqBuilder:
        """
        Order price 
        """
        self.obj['price'] = value
        return self

    def set_leverage(self, value: int) -> GetMaxOpenSizeReqBuilder:
        """
        Leverage 
        """
        self.obj['leverage'] = value
        return self

    def build(self) -> GetMaxOpenSizeReq:
        return GetMaxOpenSizeReq(**self.obj)
