# Code generated by Kucoin Universal SDK Generator; DO NOT EDIT.

from abc import ABC, abstractmethod
from typing import Any
from kucoin_universal_sdk.internal.interfaces.transport import Transport
from .model_get_margin_risk_limit_req import GetMarginRiskLimitReq
from .model_get_margin_risk_limit_resp import GetMarginRiskLimitResp


class RiskLimitAPI(ABC):

    @abstractmethod
    def get_margin_risk_limit(self, req: GetMarginRiskLimitReq,
                              **kwargs: Any) -> GetMarginRiskLimitResp:
        """
        summary: Get Margin Risk Limit
        description: Request via this endpoint to get the Configure and Risk limit info of the margin.
        documentation: https://www.kucoin.com/docs-new/api-3470219
        +---------------------+---------+
        | Extra API Info      | Value   |
        +---------------------+---------+
        | API-DOMAIN          | SPOT    |
        | API-CHANNEL         | PRIVATE |
        | API-PERMISSION      | GENERAL |
        | API-RATE-LIMIT-POOL | SPOT    |
        | API-RATE-LIMIT      | 20      |
        +---------------------+---------+
        """
        pass


class RiskLimitAPIImpl(RiskLimitAPI):

    def __init__(self, transport: Transport):
        self.transport = transport

    def get_margin_risk_limit(self, req: GetMarginRiskLimitReq,
                              **kwargs: Any) -> GetMarginRiskLimitResp:
        return self.transport.call("spot", False, "GET",
                                   "/api/v3/margin/currencies", req,
                                   GetMarginRiskLimitResp(), False, **kwargs)
